// Copyright (c) Microsoft Corporation.
// All rights reserved.
//
// This code is licensed under the MIT License.
//
// Permission is hereby granted, free of charge, to any person obtaining a copy
// of this software and associated documentation files(the "Software"), to deal
// in the Software without restriction, including without limitation the rights
// to use, copy, modify, merge, publish, distribute, sublicense, and / or sell
// copies of the Software, and to permit persons to whom the Software is
// furnished to do so, subject to the following conditions :
//
// The above copyright notice and this permission notice shall be included in
// all copies or substantial portions of the Software.
//
// THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
// IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
// FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
// AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
// LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
// OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
// THE SOFTWARE.

extern NSString *const MSID_OAUTH2_ACCESS_TOKEN;
extern NSString *const MSID_OAUTH2_AUTHORIZATION;
extern NSString *const MSID_OAUTH2_AUTHORIZE_SUFFIX;
extern NSString *const MSID_OAUTH2_TOKEN_SUFFIX;
extern NSString *const MSID_OAUTH2_AUTHORIZATION_CODE;
extern NSString *const MSID_OAUTH2_AUTHORIZATION_URI;
extern NSString *const MSID_OAUTH2_AUTHORITY;
extern NSString *const MSID_OAUTH2_BEARER;
extern NSString *const MSID_OAUTH2_CLIENT_ID;
extern NSString *const MSID_OAUTH2_CLAIMS;
extern NSString *const MSID_OAUTH2_CODE;
extern NSString *const MSID_OAUTH2_ERROR;
extern NSString *const MSID_OAUTH2_ERROR_DESCRIPTION;
extern NSString *const MSID_OAUTH2_ERROR_SUBCODE;
extern NSString *const MSID_OAUTH2_EXPIRES_IN;
extern NSString *const MSID_OAUTH2_GRANT_TYPE;
extern NSString *const MSID_OAUTH2_REDIRECT_URI;
extern NSString *const MSID_OAUTH2_REFRESH_TOKEN;
extern NSString *const MSID_OAUTH2_RESOURCE;
extern NSString *const MSID_OAUTH2_RESPONSE_TYPE;
extern NSString *const MSID_OAUTH2_SCOPE;
extern NSString *const MSID_OAUTH2_STATE;
extern NSString *const MSID_OAUTH2_SUB_ERROR;
extern NSString *const MSID_OAUTH2_TOKEN;
extern NSString *const MSID_OAUTH2_INSTANCE_DISCOVERY_SUFFIX;
extern NSString *const MSID_OAUTH2_TOKEN_TYPE;
extern NSString *const MSID_OAUTH2_LOGIN_HINT;
extern NSString *const MSID_OAUTH2_ID_TOKEN;
extern NSString *const MSID_OAUTH2_CORRELATION_ID_RESPONSE;
extern NSString *const MSID_OAUTH2_CORRELATION_ID_REQUEST;
extern NSString *const MSID_OAUTH2_CORRELATION_ID_REQUEST_VALUE;
extern NSString *const MSID_OAUTH2_SAML11_BEARER_VALUE;
extern NSString *const MSID_OAUTH2_SAML2_BEARER_VALUE;
extern NSString *const MSID_OAUTH2_SCOPE_OPENID_VALUE;
extern NSString *const MSID_OAUTH2_SCOPE_OFFLINE_ACCESS_VALUE;
extern NSString *const MSID_OAUTH2_SCOPE_PROFILE_VALUE;
extern NSString *const MSID_OAUTH2_ASSERTION;
extern NSString *const MSID_OAUTH2_CLIENT_TELEMETRY;
extern NSString *const MSID_OAUTH2_PROMPT;
extern NSString *const MSID_OAUTH2_PROMPT_NONE;

extern NSString *const MSID_OAUTH2_EXPIRES_ON;
extern NSString *const MSID_OAUTH2_EXT_EXPIRES_IN;
extern NSString *const MSID_FAMILY_ID;
extern NSString *const MSID_AUTH_CLOUD_INSTANCE_HOST_NAME;
extern NSString *const MSID_ENROLLMENT_ID;

// Used for PKCE support
extern NSString *const MSID_OAUTH2_CODE_CHALLENGE;
extern NSString *const MSID_OAUTH2_CODE_CHALLENGE_METHOD;
extern NSString *const MSID_OAUTH2_CODE_VERIFIER;

// AAD user identifiers
extern NSString *const MSID_OAUTH2_CLIENT_INFO;
extern NSString *const MSID_OAUTH2_UNIQUE_IDENTIFIER;
extern NSString *const MSID_OAUTH2_UNIQUE_TENANT_IDENTIFIER;

extern NSString *const MSID_OAUTH2_DOMAIN_REQ;
extern NSString *const MSID_OAUTH2_LOGIN_REQ;

extern NSString *const MSID_OAUTH2_ADDITIONAL_SERVER_INFO;
extern NSString *const MSID_OAUTH2_ENVIRONMENT;

extern NSString *const MSID_PROTECTION_POLICY_REQUIRED;
extern NSString *const MSID_USER_DISPLAYABLE_IDENTIFIER;

extern NSString *const MSID_CREDENTIAL_TYPE_CACHE_KEY;
extern NSString *const MSID_ENVIRONMENT_CACHE_KEY;
extern NSString *const MSID_REALM_CACHE_KEY;
extern NSString *const MSID_AUTHORITY_CACHE_KEY;
extern NSString *const MSID_HOME_ACCOUNT_ID_CACHE_KEY;
extern NSString *const MSID_ENROLLMENT_ID_CACHE_KEY;
extern NSString *const MSID_CLIENT_ID_CACHE_KEY;
extern NSString *const MSID_FAMILY_ID_CACHE_KEY;
extern NSString *const MSID_TOKEN_CACHE_KEY;
extern NSString *const MSID_USERNAME_CACHE_KEY;
extern NSString *const MSID_TARGET_CACHE_KEY;
extern NSString *const MSID_CLIENT_INFO_CACHE_KEY;
extern NSString *const MSID_ID_TOKEN_CACHE_KEY;
extern NSString *const MSID_ADDITIONAL_INFO_CACHE_KEY;
extern NSString *const MSID_EXPIRES_ON_CACHE_KEY;
extern NSString *const MSID_OAUTH_TOKEN_TYPE_CACHE_KEY;
extern NSString *const MSID_CACHED_AT_CACHE_KEY;
extern NSString *const MSID_EXTENDED_EXPIRES_ON_CACHE_KEY;
extern NSString *const MSID_SPE_INFO_CACHE_KEY;
extern NSString *const MSID_RESOURCE_RT_CACHE_KEY;
extern NSString *const MSID_LOCAL_ACCOUNT_ID_CACHE_KEY;
extern NSString *const MSID_AUTHORITY_TYPE_CACHE_KEY;
extern NSString *const MSID_GIVEN_NAME_CACHE_KEY;
extern NSString *const MSID_MIDDLE_NAME_CACHE_KEY;
extern NSString *const MSID_FAMILY_NAME_CACHE_KEY;
extern NSString *const MSID_NAME_CACHE_KEY;
extern NSString *const MSID_ALTERNATIVE_ACCOUNT_ID_KEY;
extern NSString *const MSID_SESSION_KEY_CACHE_KEY;
extern NSString *const MSID_ACCOUNT_CACHE_KEY;
extern NSString *const MSID_LAST_MOD_TIME_CACHE_KEY;
extern NSString *const MSID_LAST_MOD_APP_CACHE_KEY;
extern NSString *const MSID_APPLICATION_IDENTIFIER_CACHE_KEY;

extern NSString *const MSID_ACCESS_TOKEN_CACHE_TYPE;
extern NSString *const MSID_ACCOUNT_CACHE_TYPE;
extern NSString *const MSID_REFRESH_TOKEN_CACHE_TYPE;
extern NSString *const MSID_APPLICATION_METADATA_CACHE_TYPE;
extern NSString *const MSID_ACCOUNT_METADATA_CACHE_TYPE;
extern NSString *const MSID_LEGACY_TOKEN_CACHE_TYPE;
extern NSString *const MSID_ID_TOKEN_CACHE_TYPE;
extern NSString *const MSID_LEGACY_ID_TOKEN_CACHE_TYPE;
extern NSString *const MSID_PRT_TOKEN_CACHE_TYPE;
extern NSString *const MSID_GENERAL_TOKEN_CACHE_TYPE;
extern NSString *const MSID_GENERAL_CACHE_ITEM_TYPE;
extern NSString *const MSID_APP_METADATA_CACHE_TYPE;
extern NSString *const MSID_APP_METADATA_AUTHORITY_MAP_TYPE;

extern NSString *const MSID_OPENID_CONFIGURATION_SUFFIX;
extern NSString *const MSID_PREFERRED_USERNAME_MISSING;

extern NSString *const MSIDServerErrorClientMismatch;
extern NSString *const MSIDServerErrorBadToken;
